"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _icon = require("antd/es/icon");

var _icon2 = _interopRequireDefault(_icon);

var _tooltip = require("antd/es/tooltip");

var _tooltip2 = _interopRequireDefault(_tooltip);

var _avatar = require("antd/es/avatar");

var _avatar2 = _interopRequireDefault(_avatar);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require("antd/es/icon/style/css");

require("antd/es/tooltip/style/css");

require("antd/es/avatar/style/css");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _dayjs = require("dayjs");

var _dayjs2 = _interopRequireDefault(_dayjs);

require("dayjs/locale/zh-cn");

var _relativeTime = require("dayjs/plugin/relativeTime");

var _relativeTime2 = _interopRequireDefault(_relativeTime);

var _Comment = require("../../Comment");

var _Comment2 = _interopRequireDefault(_Comment);

var _CommentInput = require("../CommentInput");

var _CommentInput2 = _interopRequireDefault(_CommentInput);

var _avatar3 = require("../../avatar");

var _avatar4 = _interopRequireDefault(_avatar3);

var _helper = require("../../helper");

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

_dayjs2.default.locale("zh-cn");
_dayjs2.default.extend(_relativeTime2.default);

var CommentItem = function (_Component) {
  _inherits(CommentItem, _Component);

  function CommentItem(props) {
    _classCallCheck(this, CommentItem);

    var _this = _possibleConstructorReturn(this, (CommentItem.__proto__ || Object.getPrototypeOf(CommentItem)).call(this, props));

    _this.state = {
      showInput: false
    };
    _this.handleToggleInput = _this.handleToggleInput.bind(_this);
    _this.renderTextWithReply = _this.renderTextWithReply.bind(_this);
    return _this;
  }

  _createClass(CommentItem, [{
    key: "handleToggleInput",
    value: function handleToggleInput() {
      this.setState({ showInput: !this.state.showInput });
    }
  }, {
    key: "renderTextWithReply",
    value: function renderTextWithReply(text, content) {
      var newText = text;
      var reply = content.reply;

      if (reply) {
        newText = newText + " //@<a href=\"/" + reply.user_id + "\">" + reply.user_name + "</a> " + reply.content;
        if (reply.reply) {
          return this.renderTextWithReply(newText, reply);
        }
      }
      return newText;
    }
  }, {
    key: "render",
    value: function render() {
      var _props = this.props,
          commentId = _props.commentId,
          replyId = _props.replyId,
          content = _props.content,
          action = _props.action,
          showReply = _props.showReply,
          onShowReply = _props.onShowReply,
          app = _props.app;
      var showInput = this.state.showInput;


      return _react2.default.createElement(
        "div",
        { className: "comment-item-box" },
        _react2.default.createElement(
          "div",
          { className: "comment-item-left" },
          _react2.default.createElement(_avatar2.default, { src: content.user_avatar || _avatar4.default, size: "large" })
        ),
        _react2.default.createElement(
          "div",
          { className: "comment-item-right" },
          _react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              "a",
              { href: "/" + content.user_id },
              content.user_name || "暂无昵称"
            ),
            _react2.default.createElement(
              "span",
              { style: { marginLeft: 10 } },
              _react2.default.createElement(
                _tooltip2.default,
                {
                  placement: "top",
                  title: (0, _dayjs2.default)(content.created * 1000).format("YYYY-MM-DD HH:mm:ss")
                },
                (0, _dayjs2.default)(content.created * 1000).fromNow()
              )
            )
          ),
          _react2.default.createElement("div", {
            className: "comment-item-content",
            dangerouslySetInnerHTML: {
              __html: (0, _helper.renderContent)(this.renderTextWithReply(content.content, content))
            }
          }),
          _react2.default.createElement(
            "div",
            { className: "comment-item-bottom" },
            content.reply_count ? _react2.default.createElement(
              "div",
              null,
              _react2.default.createElement(
                "a",
                { className: "comment-item-bottom-left", onClick: onShowReply },
                content.reply_count,
                " \u6761\u56DE\u590D",
                showReply ? _react2.default.createElement(_icon2.default, { type: "up" }) : _react2.default.createElement(_icon2.default, { type: "down" })
              )
            ) : null,
            _react2.default.createElement(
              "a",
              {
                onClick: this.handleToggleInput,
                className: "comment-item-bottom-right"
              },
              "\xA0 \u56DE\u590D"
            ),
            _react2.default.createElement(
              "div",
              {
                className: "comment-item-bottom-right",
                onClick: function onClick() {
                  if (replyId) {
                    // 如果有 replyId，则说明是评论的回复
                    app.sReplyFavor(content.id, commentId, content.favored);
                    return;
                  }
                  app.sCommentFavor(content.id, content.favored);
                }
              },
              _react2.default.createElement(_icon2.default, {
                type: "like-o",
                className: content.favored ? "comment-favored" : ""
              }),
              "\xA0",
              content.favor_count
            )
          )
        ),
        showInput && _react2.default.createElement(_CommentInput2.default, {
          content: app.children,
          action: action,
          replyId: replyId,
          commentId: commentId,
          callback: this.handleToggleInput
        })
      );
    }
  }]);

  return CommentItem;
}(_react.Component);

CommentItem.propTypes = {
  content: _propTypes2.default.object.isRequired,
  // comment 评论
  // reply 评论的回复
  // replyToReply 回复的回复
  action: _propTypes2.default.oneOf(["comment", "reply", "replyToReply"]),
  onShowReply: _propTypes2.default.func
};

CommentItem.defaultProps = {
  action: "comment",
  onShowReply: function onShowReply() {}
};

exports.default = (0, _Comment2.default)(CommentItem);
//# sourceMappingURL=index.js.map