"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isFunction = isFunction;
exports.isUrl = isUrl;
exports.arrayToObject = arrayToObject;
exports.renderContent = renderContent;

var _constant = require("./constant");

var _emoji = require("./emoji");

var _emoji2 = _interopRequireDefault(_emoji);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isFunction(functionToCheck) {
  return functionToCheck && {}.toString.call(functionToCheck) === "[object Function]";
}

function isUrl(userInput) {
  var regexp = /(http(s)?:\/\/.)?(www\.)?[-a-zA-Z0-9@:%._+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_+.~#?&//=]*)/g;
  var res = userInput.match(regexp);
  if (res === null) return false;else return true;
}

/**
 * 将对象数组转换为对象
 * @param {array} array Array of Objects
 * @param {string} keyField string
 */
function arrayToObject(array, keyField) {
  return array.reduce(function (obj, item) {
    obj[item[keyField]] = item;
    return obj;
  }, {});
}

/**
 * 渲染编辑器
 * [x] => <img src="x" />
 * @param {strig} content
 */
function renderContent(content, onClick) {
  return content.replace(_constant.REGEXP, function (a, b) {
    var src = a.slice(1, -1);
    if (isUrl(src)) {
      return "<img src=\"" + src + "\" alt=\"" + src + "\" style=\"max-width: 300px\" />";
    }
    var emojiObejct = arrayToObject(_emoji2.default, "title");
    var value = emojiObejct[src].value;
    return "<img src=\"" + _emoji.prefixUrl + value + "." + _emoji.ext + "\" alt=\"" + value + "\" />";
  });
}
//# sourceMappingURL=helper.js.map